<template>
  <div >
    <ApplyLeave
      v-bind.sync="Leave"
      v-on:submit="submit"
      v-on:cancel="cancel"
    >
    </ApplyLeave>
  </div>
</template>

<script>
import ApplyLeave from '@/components/employeePanel/ApplyLeave.vue';
import { mapGetters } from 'vuex';
import { getAuthenticatedUser } from '@/fb';
import Leave from '@/models/ApplyLeave';

export default {
  components: {
    ApplyLeave,
  },
  data() {
    return {
      Leave: new Leave(),
    };
  },
  computed: {
    ...mapGetters({
      snackbarText: 'getSnackbarText',
      showSnackbar: 'getShowSnackbar',
      user: 'getUser',
    }),
  },
  mounted() {
    getAuthenticatedUser().then((user) => {
      console.log('Got user: ', user);
      this.Leave.uid = user.uid;
      this.Leave.name = this.user.displayName;
    });
  },
  methods: {
    submit() {
      this.Leave.create().then(() => {
        console.log('Done creating note', this.Leave.id);
        this.$store.dispatch('setSnackbarText', 'Apply for leave successfully');
        this.$store.dispatch('setShowSnackbar', true);
        this.$router.replace({ name: 'Employeeleave' });
      });
    },
    cancel() {
      this.$router.replace({ name: 'Employeeleave' });
    },
  },
};
</script>
